#include <iostream>
#include <octave/oct.h>
#include "omatrix.h"

using namespace std;

double rnd_cell(int row, int column)
{
   return 5 * rand();
}

double identity(int row, int column)
{
   return (row == column);
}

int main()
{
   srand(time(0));
   
   oMatrix m1(5,5);
   oMatrix m2(5,5);

   cout << "Let's create two random square matrices and multiply them together!\n";

   m1.Fill(0, 0, 4, 4, rnd_cell);
   m2.Fill(0, 0, 4, 4, rnd_cell);

   cout << "Matrix A is \n" << m1 << "\n\nMatrix B is \n" << m2 << "\n\n"
        << "I will now multiply them to get \n" << m1 * m2 << endl;

   oMatrix rv1(5,1);
   oMatrix cv1(1,5);
   oMatrix rv2(5,1);
   oMatrix cv2(1,5);

   cv1.Fill(0,0,0,4,rnd_cell);
   cv2.Fill(0,0,0,4,rnd_cell);
   rv1.Fill(0,0,4,0,rnd_cell);
   rv2.Fill(0,0,4,0,rnd_cell);

   cout << "Generate two row and two column vectors to demonstrate vector operations\n\n";
   cout << "Dot product is intentionally not supported as it would expose unsafe"
        << "operations. Use matrix multiplication instead to enforce dimension"
        << " requirements.\n\nr1=\n";

   cout << rv1 << endl << "rv2=\n" << rv2 << endl << "cv1=\n" << cv1 << endl << "cv2=" << endl << cv2 << endl << endl;

   cout << "rv1 * rv2' = " << (rv1.transpose() * rv2)
        << "\ncv1 * rv1 = " << cv1 * rv1
        << "\ncv1 * cv2' = " << cv1 * cv2.transpose() << endl << endl;

   cout << "Hey guys, I can transpose: \nrv1' = " << rv1.transpose();

   cout << "Now let's do a 5x5 matrix transpose. Original:\n" << m1 << "\nTranspose:\n" << m1.transpose() << endl << endl;

   oMatrix A(2,2);

   A.Fill(0,0,1,1,rnd_cell);

   A = 1 - A;

   oMatrix b = A.inverse();

   cout << "Generated random matrix A = \n" << A << "\n\nA^-1 = \n" << b
        << "\n\nA * A^-1 =\n" << b * A << endl;
}
