#include "omatrix.h"
#include <math.h>

const double NaN = sqrt(-1);

oMatrix::oMatrix()
:Matrix() { }

oMatrix::oMatrix(int rows, int cols)
:Matrix(rows, cols) { }

oMatrix::oMatrix(const Matrix& m)
:Matrix(m)
{ }

void oMatrix::Set(int row, int col, double val)
{ fill(val, row, col, row, col); }

double oMatrix::Get(int row, int col)
{ extract(row, col, row, col); }

void oMatrix::Fill(int row1, int col1, int row2, int col2,
                   double (*fxn)(int row, int column))
{
   if (row1 > row2)
   {
      double tmp = row1;
      row1 = row2;
      row2 = tmp;
   }

   if (col1 > col2)
   {
      double tmp = col1;
      col1 = col2;
      col2 = tmp;
   }

   for (int r = row1; r <= row2; r++)
   {
      for (int c = col1; c <= col2; c++)
      {
         Set(r, c, fxn(r, c));
      }
   }
}

int oMatrix::Rows() const
{
   RowVector t = row(0);
   return t.length();
}

int oMatrix::Cols() const
{
   ColumnVector t = column(0);
   return t.length();
}

